<?
//    LaNewsFactory - web news engine written in PHP
//    Copyright (C) 2000 Christophe Brocas - christophe.brocas@free.fr
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

define("yes", 1);
define("no", 0);
define("left", 0);
define("right", 1);
define("none", 2);

include "sitesettings.php3";

if ($way==0) // Forum attitude
{
 if ((!isset($currenttopic)) || ($currenttopic == "AllTopics"))
 {
    setcookie("currenttopic","AllTopics",time()+86400);
    $currenttopic="AllTopics";
    include "usersettings.php3"; 
 }
 else
    include "news/$currenttopic-usersettings.php3";
}
else // News system attitude 
{
 if (!isset($currenttopic))
 {
    setcookie("currenttopic","AllTopics",time()+86400);
	$currenttopic="AllTopics";
 }
 include "usersettings.php3"; 
}


// Incorporation of language-dependent display variables.
if (!isset($lang))
   $lang="us";
include "lang/lang-$lang.php3";

$version="0.6.2p1";

$colour[0] = "#eeeeee";
$colour[1] = "#e8e6de";

$fonts[0] = "serif";
$fonts[1] = "sans-serif";
$fonts[2] = "cursive";
$fonts[3] = "fantasy";
$fonts[4] = "monospace";

// Check if the user has the correct password for the level requested
//
function CheckHabilitation($level,$topicn)
{
  global $way;
  
  if ($way==0) // Forum attitude 
   $topicname = "news/" . $topicn;
  else         // News system attitude
   $topicname = "news";

  $ok=0;
  switch ($level)
  {
   case "Admin":
         if ($Admin == ReadPassword())
            $ok=1;
		 break;

   case "TopicAdmin":
         if (($Admin == ReadPassword()) || ($TopicAdmin == ReadPassword("$topicname-pass.php3")))
            $ok=1;
		 break;

   case "Moderator":
         if (($Admin == ReadPassword()) || ($TopicAdmin == ReadPassword("$topicname-pass.php3")) || ($Moderator == ReadPassword("$topicname-modpass.php3")))
            $ok=1;
		 break;
  }
  
  if ($ok==0) 
  {
     setcookie("Admin","",time()+3600);
     setcookie("TopicAdmin","",time()+3600);
     setcookie("Moderator","",time()+3600);
     header("Location: " . $url . "login.php3");
	 exit;
  }
}


// Returns the date/time stored in the news when you create/answer it.
//  That is the date/time displayed when the news is displayed.
//
function getdateaffichage()
{
  return strftime("%d/%m/%Y, %Hh%M:%S");
}

// These words are keywords into message files:
// $reservedwds = array("titre#", "email#", "nom#", "date#", "corps#", "EOAR#", "BOAN#", "rep#", "EOAN#");


// Returns the date portion of the filename in which the news is stored.
//
function getdatefichier()
{
  return strftime("%Y%m%d-%H%M%S");
}


// Returns the encrypted password
//
function ReadPassword($path="pass.php3")
{
  include $path;
  return $mypass; 
}


// Store the encrypted password
//
function StorePassword($password, $path="pass.php3")
{
  $fic = fopen($path,"w");

  fputs($fic,"<?");
  fputs($fic,"\$mypass=\"$password\";");
  fputs($fic,"?>");

  fclose($fic);
}

// Returns a crypted string from a clear password
//
function MyCrypt($password)
{
  return crypt($password,"LaNewsFactory");
}


// Returns user settings in a tab 
//
function GetUserSettings($filepath="usersettings.php3")
{
  $i=0;

  $f=fopen($filepath,"r");
  $ligne = fgets($f,16000);

  while (!feof($f))
  {
    $ligne = ereg_replace("\n","",$ligne);   
    $ligne = ereg_replace("\"","",$ligne);   
    $ligne = ereg_replace(";","",$ligne);   
    
    $tab[$i]=$ligne;
 
    $i++;
    $ligne = fgets($f,16000);
  }

  return $tab;  
}


// Displays the news and its answers.
//
function DisplayArticle($path,$ans="notset")
{
global $lang, $display, $colour, $EnableHtml, $answersdepth;

$tplArt = new FastTemplate("templates/lnf"); 
$tplArt->define( array( table      => "table.tpl", 
                        row        => "row.tpl", 
                        link       => "link.tpl", 
                        newstitle  => "newstitle.tpl", 
                        bottomnews => "bottomnews.tpl", 
                        line       => "line.tpl", 
                        comment    => "comment.tpl",
                        colour0    => "colour0.tpl",
                        colour1    => "colour1.tpl",
                        colour2    => "colour2.tpl",
                        datetime   => "datetime.tpl",
                        td         => "td.tpl") ); 

$f=fopen("$path","r");

$index=1;
$nblignes=0;
$newsnotdisplayed=0;
$inanswer = 0;
$exit=0;
$light="";

$inscope=1;
$depth = $answersdepth;
$start=0;

$fname = basename($path);
$topname = GetTopic($fname);

$ligne = fgets($f,16000);

while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   if ($EnableHtml==0) 
   {
      $ligne=htmlspecialchars($ligne);
   }
   $tab = explode("#",$ligne);
   switch ($tab[0])
   {
     case "version":
       break;

	 case "titre":
       $inanswer = 0;
       $tplArt->assign(LNF_NEWS_TITLE,stripslashes($tab[1]));

       break;

     case "email":
	   if (($newsnotdisplayed==0) && ($inscope==1))
	   {
          $tab[1] = ereg_replace("@","_at_",$tab[1]);
          $tplArt->assign(LNF_LINK,"mailto:".$tab[1]);
       }
	   break;

     case "nom":
	   if (($newsnotdisplayed==0) && ($inscope==1)) 
	   {
          $tplArt->assign(LNF_DISPLAY,$tab[1]);
          $templine="";
          for ($k=0;$k < $numberoftabs; $k++) 
              $templine = $templine . "<blockquote>\n"; 
          $tplArt->assign(LNF_LINE_BODY,$templine . "<img src=\"images/comment.gif\">\n"); 
          $tplArt->parse(LNF_MAILTO,"line");
          //erase previous content of LINE_BODY
          $tplArt->assign(LNF_LINE_BODY,"");
          $tplArt->parse(LNF_MAILTO,".link");
	   }
       break;

     case "date":
	   if (($newsnotdisplayed==0) && ($inscope==1)) 
	   {
          $tplArt->assign(LNF_MAIL_DATE,$tab[1]);

          if ($inanswer==0) 
          {
             $tplArt->assign(LNF_LINK,"listdir.php3?top=$topname");
             $tplArt->assign(LNF_DISPLAY,"[".$topname."]");
             $tplArt->parse(LNF_LINK_TOPIC,"link");
             $tplArt->parse(LNF_DATE_TIME,"datetime");
          }
          else
	      {
             $templine="";
             for ($k=0;$k < $numberoftabs; $k++) 
                 $templine = $templine . "</blockquote>\n"; 
             $tplArt->assign(LNF_LINK,"answer.php3?art=$path&ans=$lastBOAN&level=$levelBOAN");
             $tplArt->assign(LNF_DISPLAY,$display[$lang]["toanswer"]);
             $tplArt->parse(LNF_LINK_TOPIC,"link");
             $tplArt->parse(LNF_TD_CONTENT,".datetime");
             $tplArt->assign(LNF_LINE_BODY,$templine); 
             $tplArt->parse(LNF_TD_CONTENT,".line");
          }
	   }
       break;

     case "corps":
       $tplArt->assign(LNF_TD_WIDTH,"100%");
       $tplArt->parse(LNF_TD_CONTENT,"newstitle");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->parse(LNF_TABLE_ROWS,".row");
   
       $light="";
       // Erase previous content of TD_CONTENT
       $tplArt->parse(LNF_TD_CONTENT,"comment");
       $tplArt->assign(LNF_TD_WIDTH,"100%");

       if ($index==0)
          $index = 1;
       else
          $index = 0;

       break;

     case "rep":
       if (($newsnotdisplayed==0) && ($inscope==1))
	   {
          $light = $light . "  <blockquote>\n";
          $nblignes=0;
	   }
       break;

     case "EOAR":
       if ($ans!="notset") 
          $inscope=0;
		  
       $tplArt->assign(LNF_LINE_BODY,$light); 
       $tplArt->parse(LNF_TD_CONTENT,".line");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->parse(LNF_TABLE_ROWS,".row");
       $tplArt->assign(LNF_TABLE_WIDTH,"95%");
       $tplArt->parse(FINAL,"table");

      $tplArt->FastPrint(FINAL);

       $light="";
       $tplArt->parse(LNF_TD_CONTENT,"comment");
       $tplArt->parse(LNF_ROW,"comment");
       $tplArt->parse(LNF_TABLE_ROWS,"comment");

       if ($index==0)
          $index = 1;
       else
          $index = 0;
	   
       $inanswer = 1;

       break;

     case "EOAN":
	   if (($newsnotdisplayed==0) && ($inscope==1))
	   {        
          $light = $light . "<br>\n</blockquote>\n";

          if ($ans=="notset") 
          {
             for ($k=0;$k < $numberoftabs; $k++) 
                 $light = $light . "</blockquote>\n"; 
          }
          else
             for ($k=$start;$k<=$numberoftabs-$start;$k++) 
                 $light = $light . "</blockquote>\n"; 
                   
          if ($index==0)
             $index = 1;
          else
             $index = 0;

          $tplArt->assign(LNF_LINE_BODY,$light);
          $tplArt->parse(LNF_TD_CONTENT,".line");
          $tplArt->parse(LNF_ROW,"td");
          $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
          $tplArt->parse(LNF_TABLE_ROWS,".row");

          $tplArt->parse(LNF_TD_CONTENT,"comment");
          $tplArt->assign(LNF_LINE_BODY,"");
          $light = "";
	   }
       break;

     case "BOAN":
	   if ($inscope==0) 
	   {
	      if ($tab[1]==$ans) 
		  {
		     $inscope=1;
			 $depth=$tab[3] + $answersdepth;
			 $start=$tab[3];
	 
			 $lastBOAN=$tab[1];
			 $levelBOAN=$tab[3]+1;
		               
			 if ($index==0)
				$index = 1;
			 else
				$index = 0;
		  }
	   }
	   else
	   {
	   if (($tab[3]<=$start) && ($ans!="notset"))
	   {
          $exit=1;
	   }
	   elseif ($depth > $tab[3]) 
	   {
		 if ($newsnotdisplayed!=0) 
         {
            for ($k=0;$k < $depth; $k++) 
                $light = $light . "<blockquote>\n"; 

            $tplArt->assign(LNF_LINE_BODY,$light);
            $tplArt->parse(LNF_TD_CONTENT,".line");
            $light="";

            $tplArt->assign(LNF_LINK,"print.php3?art=$path&ans=$lastBOAN");
            $tplArt->assign(LNF_DISPLAY,$newsnotdisplayed . " " . $display[$lang]["answer"] . "(s) ...");
            $tplArt->parse(LNF_TD_CONTENT,".link");

            $light = $light . "<br>\n"; 

            for ($k=0;$k < $depth; $k++) 
                $light = $light . "</blockquote>\n"; 

			if ($index==0)
               $index = 1;
            else
               $index = 0;

            $tplArt->assign(LNF_LINE_BODY,$light); 
            $tplArt->parse(LNF_TD_CONTENT,".line");
            $tplArt->parse(LNF_ROW,"td");
            $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
            $tplArt->parse(LNF_TABLE_ROWS,".row");
			
			$newsnotdisplayed=0;
            $tplArt->parse(LNF_TD_CONTENT,"comment");
            $tplArt->assign(LNF_LINE_BODY,"");
            $light = "";
         }
        
         $lastBOAN=$tab[1];
	     $levelBOAN=$tab[3]+1;
       
         $numberoftabs=$tab[3];
	     if ($ans=="notset") 
	     {
	       for ($k=0;$k < $numberoftabs; $k++) 
                $light = $light . "<blockquote>\n"; 
	     }
		 else
		   for ($k=$start;$k<=$numberoftabs-$start;$k++) 
               $light = $light . "<blockquote>\n"; 

       }
	   else
         $newsnotdisplayed++;
	   }
       break;

     default:
	   if (($newsnotdisplayed==0) && ($inscope==1)) 
	   {
          $nblignes = $nblignes + 1;
          if ($nblignes == 1)
             $light = $light . "  " . stripslashes($ligne) . "\n"; 
          else
             $light = $light . "  <br>". stripslashes($ligne) . "\n"; 
       }
	   break;

   }
   $ligne = fgets($f,16000); 
   if ($exit==1) 
      break;
}

// In case of always deeper answers -> it would never displays the "N news not displayed" link.
if ($newsnotdisplayed!=0) 
{
    for ($k=0;$k < $depth; $k++) 
        $light = $light . "<blockquote>\n"; 

    $tplArt->assign(LNF_LINE_BODY,$light);
    $tplArt->parse(LNF_TD_CONTENT,".line");
    $light="";

    $tplArt->assign(LNF_LINK,"print.php3?art=$path&ans=$lastBOAN");
    $tplArt->assign(LNF_DISPLAY,$newsnotdisplayed . " " . $display[$lang]["answer"] . "(s) ...");
    $tplArt->parse(LNF_TD_CONTENT,".link");

    $light = $light . "<br>\n"; 

    for ($k=0;$k < $depth; $k++) 
        $light = $light . "</blockquote>\n"; 

    if ($index==0)
       $index = 1;
    else
       $index = 0;

    $tplArt->assign(LNF_LINE_BODY,$light); 
    $tplArt->parse(LNF_TD_CONTENT,".line");
    $tplArt->parse(LNF_ROW,"td");
    $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
    $tplArt->parse(LNF_TABLE_ROWS,".row");

    $newsnotdisplayed=0;
    $tplArt->parse(LNF_TD_CONTENT,"comment");
    $tplArt->assign(LNF_LINE_BODY,"");
    $light = "";
}

$tplArt->assign(LNF_TABLE_WIDTH,"95%");
$tplArt->parse(FINAL,"table");
$tplArt->FastPrint(FINAL);
fclose($f);
}

// Edit an article for edit purposes
//
function EditArticle($path,$link="moderatenews.php3")
{

global $lang, $display, $colour, $EnableHtml;

$f=fopen("$path","r");

$index=1;
$nblignes=0;


// HTML Table only there to make a dark border

print "     <form action=\"$link\" method=\"post\">";
print "        <input type=\"hidden\" name=\"art\"    value=\"" . $path . "\">";
print "        <input type=\"hidden\" name=\"modify\" value=\"1\">";

$tplArt = new FastTemplate("templates/lnf"); 
$tplArt->define( array( table      => "table.tpl", 
                      row        => "row.tpl", 
                      line       => "line.tpl", 
                      colour0    => "colour0.tpl",
                      colour1    => "colour1.tpl",
                      colour2    => "colour2.tpl",
                      td         => "td.tpl") ); 

$ligne = fgets($f,16000);
$exit=0;

while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   if ($EnableHtml==0) 
   {
     $ligne=HtmlEntities($ligne);
   }
   $tab = explode("#",$ligne);
   switch ($tab[0])
   {
   case "version":
       break;

   case "titre":
       $tplArt->assign(LNF_TD_WIDTH,"25%");
       if ($link=="moderatenews.php3") 
           $tplArt->assign(LNF_TD_CONTENT,"<b>".$display[$lang]["moderation"]."</b>");
       else
           $tplArt->assign(LNF_TD_CONTENT,"<b>".$display[$lang]["modify"]."</b>");
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->assign(LNF_TD_WIDTH,"75%");
       $tplArt->assign(LNF_TD_CONTENT,"&nbsp;");
       $tplArt->parse(LNF_ROW,".td");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
       $tplArt->parse(LNF_TABLE_ROWS,"row");

       $tplArt->assign(LNF_TD_WIDTH,"25%");
       $tplArt->assign(LNF_TD_CONTENT,$display[$lang]["title"]);
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->assign(LNF_TD_WIDTH,"75%");
       $tplArt->assign(LNF_TD_CONTENT,"<input type=\"text\" name=\"titre\" value=\"" .  stripslashes($tab[1]) . "\" size=\"30\" maxlength=\"30\">");
       $tplArt->parse(LNF_ROW,".td");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour0");
       $tplArt->parse(LNF_TABLE_ROWS,".row");


       if ($index==0)
          $index = 1;
       else
          $index = 0;

       break;

   case "corps":
       $line= "<textarea name=\"corps\" rows=20 cols=40 wrap=PHYSICAL>";
       break;

   case "EOAR":
       $line=$line."</textarea></center>";
       $tplArt->assign(LNF_TD_WIDTH,"25%");
       $tplArt->assign(LNF_TD_CONTENT,"&nbsp;");
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->assign(LNF_TD_WIDTH,"75%");
       $tplArt->assign(LNF_TD_CONTENT,$line);
       $tplArt->parse(LNF_ROW,".td");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour0");
       $tplArt->parse(LNF_TABLE_ROWS,".row");

       $tplArt->assign(LNF_TD_WIDTH,"25%");
       $tplArt->assign(LNF_TD_CONTENT,"&nbsp;");
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->assign(LNF_TD_WIDTH,"75%");
       $tplArt->assign(LNF_TD_CONTENT,"<input type=\"submit\" value=\"" . $display[$lang]["modify"] . "\">");
       $tplArt->parse(LNF_ROW,".td");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
       $tplArt->parse(LNF_TABLE_ROWS,".row");

       $nblignes=0;
       $exit=1;
       
       $tplArt->assign(LNF_TABLE_WIDTH,"95%");
$tplArt->parse(FINAL,"table");

      $tplArt->FastPrint(FINAL);
	   break;

   case "email":
       echo "<input type=\"hidden\" name=\"email\" value=\"" . stripslashes($tab[1]) . "\">";
       break;

   case "nom":
       $tplArt->assign(LNF_TD_WIDTH,"25%");
       $tplArt->assign(LNF_TD_CONTENT,$display[$lang]["name"]);
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->assign(LNF_TD_WIDTH,"75%");
       $tplArt->assign(LNF_TD_CONTENT,"<input  name=\"nom\" value=\"" . stripslashes($tab[1]) . "\">");
       $tplArt->parse(LNF_ROW,".td");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour0");
       $tplArt->parse(LNF_TABLE_ROWS,".row");

       break;

   case "date":
       echo "<input type=\"hidden\" name=\"date\" value=\"" . $tab[1] . "\">";
       break;
       
   default:
       $nblignes = $nblignes + 1;
       if ($nblignes == 1)
           $line=$line . stripslashes($ligne);
       else
           $line=$line . stripslashes($ligne);
       break;

   }
   if ($exit == 1)
      break;

   $ligne = fgets($f,16000);
}

echo "</form>";

fclose($f);
}

// Save an article when is modified in moderation phase
//
Function SaveArticle($art, $titre, $corps, $email, $nom, $date, $fromwhere)
{


  switch ($fromwhere)
  {
    case "moderate":
         $fic = fopen($art,"w+");
         fputs($fic,"version#2\n");
		 fputs($fic,"titre#$titre\n");
         fputs($fic,"email#$email\n");
         fputs($fic,"nom#$nom\n");
         fputs($fic,"date#$date\n");
         fputs($fic,"corps#\n");
		 if (strrpos($corps,"\n")==strlen($corps)) 
            fputs($fic,"$corps");
		 else
            fputs($fic,"$corps\n");
         fputs($fic,"EOAR#\n");
         fclose($fic); 
		 break;

    case "manage":
         $fic = fopen($art . "bak","w+");
         fputs($fic,"version#2\n");
         fputs($fic,"titre#$titre\n");
         fputs($fic,"email#$email\n");
         fputs($fic,"nom#$nom\n");
         fputs($fic,"date#$date\n");
         fputs($fic,"corps#\n");
		 if (strrpos($corps,"\n")==strlen($corps)) 
            fputs($fic,"$corps");
		 else
            fputs($fic,"$corps\n");
         fputs($fic,"EOAR#\n");

         $go=0;
         $fic2 = fopen($art,"r");
         $ligne = fgets($fic2,16000); 
         $ligne = ereg_replace("\n","",$ligne);   
		 while (!feof($fic2))
         {
           $tab = explode("#",$ligne);
           switch ($tab[0])
           {
             case "EOAR":
                  $go = 1;
                  break;

             default:
			      if ($go==1) 
                    fputs($fic,"$ligne");
                  break;
           }

           $ligne = fgets($fic2,16000); 
         }
         fclose($fic2); 
         fclose($fic); 
	
	     unlink($art);
		 rename($art . "bak",$art);
         break;

    default:
	     break;
  }
  //  Put general Read and Write perms
  $oldumask = umask(0); 
  chmod($art,0666);
  umask($oldumask); 
}

// Checks if the string contains only letters or figures
//
function CheckString($dirname) 
{
  $length = strlen($dirname);
  $pattern = "^[0-9a-z]+$";
  return eregi($pattern, $dirname);
}


// Returns an array with all the files that exist in the directory pathname
//  and whose name include the pattern 
//
Function ListDirInArray($pattern, $pathname="news")
{
  $i=0;
  $directory = opendir("$pathname");

  // No mask used, we return all files in the directory

  if ($pattern=="")
  {
     while ($filename = readdir($directory))
     {
           $tab[$i++]=$filename;
     }
  }
  else
  {
     while ($filename = readdir($directory))
     {
        if (ereg("$pattern$",$filename)==TRUE)
           $tab[$i++]=$filename;
     }
  }

  return $tab;
}



// Returns an array with all the files that exist in the directory pathname
//  and whose name include the pattern 
//
Function DisplayLang()
{
  global $lang;

  $tab = ListDirInArray(".php3","./lang");
  $taille = sizeof($tab);
 
  $rlang = "<select name=\"newlang\" size=1>\n";

  for($i=0;$i<$taille;$i++)
  {   
    $tab1 = explode("-",$tab[$i]);
    $tab2 = explode(".",$tab1[1]);

    if ($lang==$tab2[0])
       $rlang = $rlang . "<option selected value=$tab2[0] > $tab2[0] </option>";
    else
       $rlang = $rlang . "<option value=$tab2[0]>  $tab2[0] </option>";
  }
 
  $rlang = $rlang . "</select>\n";
  
  return $rlang;
}

// Displays only the news without answers but it displays also
//  the answers numbers and the last date/time update.
//  - That function should be a part of DisplayArticle(), I know. 
//    Bad code, will be cleaned in the future ... maybe ;-)
//
function DisplayJustArticle($path)
{

global $lang, $display, $colour, $linespernews, $EnableHtml;

$tplArt = new FastTemplate("templates/lnf"); 
$tplArt->define( array( table      => "table.tpl", 
                        row        => "row.tpl", 
                        link       => "link.tpl", 
                        newstitle  => "newstitle.tpl", 
                        bottomnews => "bottomnews.tpl", 
                        noanswer   => "noanswerbottomnews.tpl",
                        datetime   => "datetime.tpl",
                        line       => "line.tpl", 
                        comment    => "comment.tpl",
                        td         => "td.tpl") ); 

$f=fopen("$path","r");

$nbcar=0;
$nblignes=0;
$index=0;
$lastanswer="";
$lastname="";
$answers=0;
$exit=0;
$light="";

$fname = basename($path);
$topname = GetTopic($fname);

$ligne = fgets($f,16000);


while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   if ($EnableHtml==no) 
   {
      $ligne=HtmlEntities($ligne);
   }
   $tab = explode("#",$ligne);
   switch ($tab[0])
   {
     case "version":
       break;

     case "titre":
       $tplArt->assign(LNF_NEWS_TITLE,stripslashes($tab[1]));

       break;

     case "email":
       $tab[1] = ereg_replace("@","_at_",$tab[1]);
       $tplArt->assign(LNF_LINK,"mailto:".$tab[1]);

       break;

     case "nom":
       $tplArt->assign(LNF_DISPLAY,$tab[1]);
       $tplArt->parse(LNF_MAILTO,"link");
       break;

     case "date":
       $tplArt->assign(LNF_MAIL_DATE,$tab[1]);
       $tplArt->assign(LNF_LINK,"listdir.php3?top=$topname");
       $tplArt->assign(LNF_DISPLAY,"[".$topname."]");
       $tplArt->parse(LNF_LINK_TOPIC,"link");
       $tplArt->parse(LNF_DATE_TIME,"datetime");

       break;

     case "corps":
       $tplArt->assign(LNF_TD_WIDTH,"100%");
       $tplArt->parse(LNF_TD_CONTENT,"newstitle");
       $tplArt->assign(LNF_BACKGROUND_COLOR,$colour[$index]);
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->parse(LNF_TABLE_ROWS,".row");
   
       $light="";
       // Erase previous content of TD_CONTENT
       $tplArt->parse(LNF_TD_CONTENT,"comment");
       $tplArt->assign(LNF_TD_WIDTH,"100%");

       if ($index==0)
          $index = 1;
       else
          $index = 0;

       break;

     case "EOAR":
       $exit = 1;
       $tplArt->assign(LNF_LINE_BODY,$light . " <br>");
       $tplArt->parse(LNF_TD_CONTENT,".line");
       $light="";
       break;

     default:
       $nblignes = $nblignes + 1;

       if (($nbcar + strlen($ligne)) > 600)
       {
          $lig = substr($ligne,0,600 - $nbcar);
          $light = $light . "     " . stripslashes($lig) . " <br><b>[...]</b> <br>";
          
          $tplArt->assign(LNF_LINE_BODY,$light);
          $tplArt->parse(LNF_TD_CONTENT,".line");
          
          $exit = 1;
       }
       elseif ($nblignes > $linespernews)
       {
          $light = $light . "   <br><b>[...]</b> <br>";

          $tplArt->assign(LNF_LINE_BODY,$light);
          $tplArt->parse(LNF_TD_CONTENT,".line");
          
          $exit = 1;
       }
       else
       {
          $nbcar  = $nbcar + strlen($ligne);

		  if ($nblignes == 1)
             $light = $light . stripslashes($ligne);
          else
             $light=  $light . "<br> ". stripslashes($ligne);
       }
 
       break;
   }

   $ligne = fgets($f,16000); 
   if ($exit == 1)
      break;
}

$StoreName=0;
$newdate=0;
$newhour=0;

while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   $tab = explode("#",$ligne);
   switch ($tab[0])
   {
     case "nom":
       if ($StoreName==1) 
          $lastname = $tab[1];

	   break;
     
	 case "date":
       if ($StoreName==1) 
       {
	      $lastanswer = $tab[1];
		  $StoreName=0;
       }
	   break;

     case "BOAN":
       $answers++;
	   // extract the date and time of the reply
	   // if it is a newer date than the previous stored
	   // then store the date to display it at the bottom of the news of the main page.
	   $tab2=explode("-",$tab[1]);
	   $datetab=(int)$tab2[1];
	   $hourtab=(int)$tab2[2];
	   if ($datetab>$newdate) 
	   {
	      $newdate=$datetab;
          $StoreName=1;
          $newhour=$hourtab;
	   }
	   elseif ($datetab==$newdate) 
	   {
	      $newdate=$datetab;
	      if ($hourtab>=$newhour) 
	      {
		    $StoreName=1;
            $newhour=$hourtab;
	      }  
	   }

       break;

     default:
       break;
   }

   $ligne = fgets($f,16000); 
}

if ($answers > 0)
{
   $tplArt->assign(LNF_LINK,"print.php3?art=$path");
   $tplArt->assign(LNF_DISPLAY,$display[$lang]["readandanswer"].">>");
   $tplArt->parse(LNF_RANDA,"link"); 

   $tplArt->assign(LNF_NUMBER_ANSWERS,$answers);
   $tplArt->assign(LNF_ANSWERS,$display[$lang]["answer"]);
   $tplArt->assign(LNF_UPDATED,$display[$lang]["updated"]);
   $tplArt->assign(LNF_LAST_DATE,$lastanswer);
   $tplArt->assign(LNF_LAST_AUTHOR,$lastname);

   $tplArt->parse(LNF_TD_CONTENT,".bottomnews");

}
else
{
   $tplArt->assign(LNF_LINK,"print.php3?art=$path");
   $tplArt->assign(LNF_DISPLAY,$display[$lang]["toanswer"] . " (0 " . $display[$lang]["answer"] . ") >>");
   $tplArt->parse(LNF_ANSWER_NEWS,"link");
   $tplArt->parse(LNF_TD_CONTENT,".noanswer");
}
fclose($f);

$tplArt->assign(LNF_BACKGROUND_COLOR,"#FFFFFF");
$tplArt->parse(LNF_ROW,"td");
$tplArt->parse(LNF_TABLE_ROWS,".row");

$tplArt->assign(LNF_TABLE_WIDTH,"95%");
$tplArt->parse(FINAL,"table");
$tplArt->FastPrint(FINAL);
}

// Return an article (title, writer, date) up to moderation in a tab
//
function DisplayShortMod($path,$ind,$checkbox,$link="moderatenews.php3")
{

global $lang, $display, $colour, $EnableHtml;

$f=fopen("$path","r");

if (($ind % 2) == 0)
   $index=0;
else
   $index=1;

$ligne = fgets($f,16000);
//echo "  <tr bgcolor=\"$colour[$index]\">\n";

while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   
   if ($EnableHtml==0) 
   {
      $ligne=HtmlEntities($ligne);
   }

   $tab = explode("#",$ligne);
   switch ($tab[0])
   {
     case "version":
       break;

     case "titre":
       //echo "   <td width=50%>\n";
	   if ($checkbox==1) 
          $rtab[0] = "<input type=\"checkbox\" name=\"message[]\" value=\"" . $path . "\">";	   
       $rtab[0] = $rtab[0] . " <a href=\"$link?art=$path\"> <big>" . stripslashes($tab[1]) . "</big></a>\n";
       //echo "    </td>\n";

       break;

     case "nom":
       //echo "    <td width=25%>" . stripslashes($tab[1]) . "</td>";
       $rtab[1] = stripslashes($tab[1]);
       break;

     case "date":
       //echo "    <td width=25%> " . stripslashes($tab[1]) . " </td>";
       $rtab[2] = stripslashes($tab[1]);
       $exit = 1;
       break;

     case "EOAR":
       $exit = 1;
       break;

     default:
       break;

   }

   $ligne = fgets($f,16000); 
   if ($exit == 1)
      break;
}

//echo "  </tr>\n";
   
fclose($f);
return $rtab;
}

// This funcions strip all reserved world from any text in input fields
//  (to avoid problems when parse news files)
//  Additionally add word "null" if the string is empty
//
function StripReservedWords ($str2chk) {

    // These words are keywords into message files:
    $reservedwds = array("titre#", "email#", "nom#", "date#", "corps#", "EOAR#", "BOAN#", "rep#", "EOAN#");

    while (list($key, $val) = each($reservedwds)) {
        $str2chk=ereg_replace("$val", " ", $str2chk);
    }

    // If string len is 0 or has spaces only the "null" string is place
    // (do not avoid blank submit, but shows something instead of nothing)
    if (!strlen(trim($str2chk)))
        $str2chk = "null";

    return $str2chk;
}

// This function tests if the email adress is valid. The code comes from example furnished
// in example of ereg function in www.php.net online help.
//
function ValidEmailAdress($emailtotest) 
{
  return ereg("^[0-9a-z]([-_.]?[0-9a-z])*@[0-9a-z]([-.]?[0-9a-z])*\\.[a-wyz][a-z](g|l|m|pa|t|u|v)?$", $emailtotest);
}

// This function extracts the topic out of the file name
//
function GetTopic($filename) 
{
  $f1 = explode(".art",$filename);
  $f2 = explode("-",$f1[0]);
  $i = sizeof($f2);
  return $f2[$i-1];
}

?>
